//----------------------------------------------------------------------------
// C main line
//----------------------------------------------------------------------------

#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
#include "delay.h" 
#include "ports.h"
#include "bits.h"


void GenerateOneThirdDutyCycle( void );				/* function prototypes */
void GenerateHalfDutyCycle( void );
void GenerateZeroCycle( void );
void GenerateCenterPosition( void );
void GenerateLessThan90( void );
void GenerateMoreThan90( void );

void DCset( unsigned char );

//
// Clocks are set such that VC3, input to PWM, is 10 Khz = 100 uS
// PWM period set to 199, them PWM output = 10,000 / (199 + 1) = 50 Hz = 20 mS
//
// Duty cycle = Pulse width value / ( Period value + 1), witrh period value = 199 + 1
// then Pulsewidth value = Duty Cycle X ( Period value + 1 ) = Duty Cycle X 200
//
// So for 35% Duty Cycle Pulsewidth value = .35 X 200 = 70
// .35 is 35% duty cycle
// So for 33% Duty Cycle Pulsewidth value = .33 X 200 = 66
//
// The above for "less than" setting on compare type in PWM properties,
//
//
// You only need one fucntion to set duty cycle, for example see  just below these
// comments. You would call it by writing "DCset( 35 );" for example to set 
// a 35% duty cycle
//

void DCset( unsigned char dc ) {

    PWM8_1_WritePulseWidth( dc );					/* set pulse width to generate a 50% duty cycle */
}

//
// No need to use next 3 functions if you use above function
//

void GenerateCenterPosition( void ) {				/* Divide by eight function */
    
    PWM8_1_WritePulseWidth( 100 );					/* set pulse width to generate a 50% duty cycle */
}


void GenerateLessThan90( void ) {					/* Divide by eight function */

    PWM8_1_WritePulseWidth( 66 );					/* set pulse width to generate a 33% duty cycle */
}


void GenerateMoreThan90( void ) {					/* Divide by eight function */

    PWM8_1_WritePulseWidth( 132 );					/* set pulse width to generate a 66% duty cycle */
}


void main( void ) {

  	unsigned int i;                     			/* Delay10msTimes var */
  	unsigned char j;                   				/* LED var */
  
  	M8C_EnableGInt ; 								// Uncomment this line to enable Global Interrupts

   	LCD_1_Start();                       			/* Init the LCD */
   	
    LCD_1_InitBG( LCD_1_SOLID_BG );
    LCD_1_Position( 0, 0 );
    LCD_1_PrCString( "Servo Motor Test" );
	
	PWM8_1_Start();									// Start up with PWM at 100 % DC as configed in its proeprties window
	
  	while(1) {

		/*
		P0_0(0); 										//Turns the LED Off.
		P0_1(0);
		P0_2(1);
		P0_3(1);
		
		Delay10msTimes(100);
		P0_0(1); //Turns the LED On.
		P0_1(1);
		P0_2(0);
		P0_3(0);
		*/
		
		//Delay50uTimes(80);
		//GenerateZeroCycle();
		
		
		//GenerateCenterPosition();
		//Delay10msTimes(90);
		//GenerateLessThan90();
		//Delay10msTimes(90);
		//GenerateMoreThan90();
		//Delay10msTimes(90);
		//GenerateZeroCycle();
		//Delay10msTimes(40);
		//Delay10msTimes(20);
		//Delay50uTimes(80);
		//Stepper test
		//PRT0DR = 0x0C;
		//P0(0x0C);
		//Delay10msTimes(1);
		//Delay50uTimes(80);
		//P0(0x06);
		//PRT0DR = 0x06;
		//Delay10msTimes(1);
		//Delay50uTimes(80);
		//P0(0x03);
		//PRT0DR = 0x03;
		//Delay10msTimes(1);
		//Delay50uTimes(80);
		//P0(0x09);
		//PRT0DR = 0x09;
		//Delay10msTimes(1);
		//Delay50uTimes(80);
		
	   /*
		P0(0x03);
        Delay10msTimes(100);
        P0(0x09);
        Delay10msTimes(100);
		*/
  	}
}
